import { readFileSync as y } from "node:fs";
import { createRequire as B } from "node:module";
import x from "@rollup/plugin-inject";
import P from "node-stdlib-browser";
import { handleCircularDependancyWarning as $ } from "node-stdlib-browser/helpers/rollup/plugin";
import S from "node-stdlib-browser/helpers/esbuild/plugin";
const c = (l) => l ? l === !0 ? !0 : l === "build" : !1, t = (l) => l ? l === !0 ? !0 : l === "dev" : !1, O = (l) => l.startsWith("node:"), E = (l) => l.replace(/^node:/, ""), F = (l = {}) => {
  const u = B(import.meta.url), p = [
    u.resolve("vite-plugin-node-polyfills/shims/buffer"),
    u.resolve("vite-plugin-node-polyfills/shims/global"),
    u.resolve("vite-plugin-node-polyfills/shims/process")
  ], g = u.resolve("vite-plugin-node-polyfills/shims/banner"), a = y(g, "utf-8"), e = {
    include: [],
    exclude: [],
    overrides: {},
    protocolImports: !0,
    ...l,
    globals: {
      Buffer: !0,
      global: !0,
      process: !0,
      ...l.globals
    }
  }, d = (o, i) => o === i || o === `node:${i}`, m = (o) => e.include.length ? !e.include.some((i) => d(o, i)) : e.exclude.some((i) => d(o, i)), v = (o) => {
    if (t(e.globals.Buffer) && /^buffer$/.test(o))
      return "vite-plugin-node-polyfills/shims/buffer";
    if (t(e.globals.global) && /^global$/.test(o))
      return "vite-plugin-node-polyfills/shims/global";
    if (t(e.globals.process) && /^process$/.test(o))
      return "vite-plugin-node-polyfills/shims/process";
    if (o in e.overrides)
      return e.overrides[o];
  };
  return {
    name: "vite-plugin-node-polyfills",
    config: (o, i) => {
      const n = i.command === "serve", b = Object.entries(P).reduce((r, [s, f]) => (!e.protocolImports && O(s) || m(s) || (r[s] = v(E(s)) || f), r), {});
      return {
        build: {
          rollupOptions: {
            onwarn: (r, s) => {
              $(r, () => {
                if (o.build?.rollupOptions?.onwarn)
                  return o.build.rollupOptions.onwarn(r, s);
                s(r);
              });
            },
            plugins: [
              {
                ...x({
                  // https://github.com/niksy/node-stdlib-browser/blob/3e7cd7f3d115ac5c4593b550e7d8c4a82a0d4ac4/README.md#vite
                  ...c(e.globals.Buffer) ? { Buffer: "vite-plugin-node-polyfills/shims/buffer" } : {},
                  ...c(e.globals.global) ? { global: "vite-plugin-node-polyfills/shims/global" } : {},
                  ...c(e.globals.process) ? { process: "vite-plugin-node-polyfills/shims/process" } : {}
                })
              }
            ]
          }
        },
        esbuild: {
          // In dev, the global polyfills need to be injected as a banner in order for isolated scripts (such as Vue SFCs) to have access to them.
          banner: n ? a : void 0
        },
        optimizeDeps: {
          exclude: [
            ...p
          ],
          esbuildOptions: {
            banner: n ? { js: a } : void 0,
            // https://github.com/niksy/node-stdlib-browser/blob/3e7cd7f3d115ac5c4593b550e7d8c4a82a0d4ac4/README.md?plain=1#L203-L209
            define: {
              ...n && t(e.globals.Buffer) ? { Buffer: "Buffer" } : {},
              ...n && t(e.globals.global) ? { global: "global" } : {},
              ...n && t(e.globals.process) ? { process: "process" } : {}
            },
            inject: [
              ...p
            ],
            plugins: [
              S(b),
              // Supress the 'injected path "..." cannot be marked as external' error in Vite 4 (emitted by esbuild).
              // https://github.com/evanw/esbuild/blob/edede3c49ad6adddc6ea5b3c78c6ea7507e03020/internal/bundler/bundler.go#L1469
              {
                name: "vite-plugin-node-polyfills-shims-resolver",
                setup(r) {
                  for (const s of p) {
                    const f = s.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), h = new RegExp(`^${f}$`);
                    r.onResolve({ filter: h }, () => ({
                      // https://github.com/evanw/esbuild/blob/edede3c49ad6adddc6ea5b3c78c6ea7507e03020/internal/bundler/bundler.go#L1468
                      external: !1,
                      path: s
                    }));
                  }
                }
              }
            ]
          }
        },
        resolve: {
          // https://github.com/niksy/node-stdlib-browser/blob/3e7cd7f3d115ac5c4593b550e7d8c4a82a0d4ac4/README.md?plain=1#L150
          alias: {
            ...b
          }
        }
      };
    }
  };
};
export {
  F as nodePolyfills
};
//# sourceMappingURL=index.js.map
